Index: /branches/OKB/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml.layout
===================================================================
--- /branches/OKB/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml.layout	(revision 4480)
+++ /branches/OKB/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml.layout	(revision 4481)
@@ -22,8 +22,8 @@
       </nodes>
     </associationConnector>
-    <classShape Id="27d0903a-8f45-4b0b-8d0e-8d632bffc702" absoluteBounds="13.25, 2.125, 2, 1.9631982421875">
+    <classShape Id="27d0903a-8f45-4b0b-8d0e-8d632bffc702" absoluteBounds="13.25, 2.125, 2, 1.7708968098958331">
       <DataClassMoniker Name="/OKBDataContext/Problem" />
       <nestedChildShapes>
-        <elementListCompartment Id="9038b68e-8013-42c0-bba9-60a0b75fffd1" absoluteBounds="13.265, 2.585, 1.9700000000000002, 1.4031982421875" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
+        <elementListCompartment Id="9038b68e-8013-42c0-bba9-60a0b75fffd1" absoluteBounds="13.265, 2.585, 1.9700000000000002, 1.2108968098958333" name="DataPropertiesCompartment" titleTextColor="Black" itemTextColor="Black" />
       </nestedChildShapes>
     </classShape>
@@ -34,5 +34,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(14.25 : 1.8862939453125); (14.25 : 2.125)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(14.25 : 1.8862939453125); (14.25 : 2.125)]" fixedFrom="Algorithm" fixedTo="Algorithm">
       <AssociationMoniker Name="/OKBDataContext/ProblemClass/ProblemClass_Problem" />
       <nodes>
@@ -47,5 +47,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(13.25 : 3.70933229417067); (10.3177083333333 : 3.70933229417067 : JumpStart); (10.0755208333334 : 3.70933229417067 : JumpEnd); (9.39129711009978 : 3.70933229417067); (9.39129711009978 : 4.375)]" manuallyRouted="true" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(13.25 : 3.73768854532225); (10.3177083333333 : 3.73768854532225 : JumpStart); (10.0755208333334 : 3.73768854532225 : JumpEnd); (9.39129711009978 : 3.73768854532225); (9.39129711009978 : 4.375)]" manuallyRouted="true" fixedFrom="Caller" fixedTo="Algorithm">
       <AssociationMoniker Name="/OKBDataContext/Problem/Problem_Experiment" />
       <nodes>
@@ -73,5 +73,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(14.25 : 4.0881982421875); (14.25 : 4.375)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(14.25 : 3.89589680989583); (14.25 : 4.375)]" fixedFrom="Algorithm" fixedTo="Algorithm">
       <AssociationMoniker Name="/OKBDataContext/Problem/Problem_ProblemParameter" />
       <nodes>
@@ -86,5 +86,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(4.75 : 2.35); (5 : 2.35)]" manuallyRouted="true" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(4.75 : 2.35); (5 : 2.35)]" manuallyRouted="true" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/OKBDataContext/Algorithm/Algorithm_AlgorithmUser" />
       <nodes>
@@ -99,5 +99,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(13.25 : 2.35); (13 : 2.35)]" manuallyRouted="true" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(13.25 : 2.32796054349691); (13.125 : 2.32796054349691); (13.125 : 2.35); (13 : 2.35)]" manuallyRouted="true" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/OKBDataContext/Problem/Problem_ProblemUser" />
       <nodes>
@@ -112,5 +112,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(8 : 2.85); (4.75 : 2.85)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(8 : 2.85); (4.75 : 2.85)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/OKBDataContext/Platform/Platform_Algorithm" />
       <nodes>
@@ -126,5 +126,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(4.75 : 3.73206647840153); (7.58333333333334 : 3.73206647840152 : JumpStart); (7.75 : 3.73206647840153 : JumpEnd); (8.66439605504989 : 3.73206647840153); (8.66439605504989 : 4.375)]" fixedFrom="Caller" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(4.75 : 3.73206647840153); (7.58333333333334 : 3.73206647840153 : JumpStart); (7.75 : 3.73206647840153 : JumpEnd); (8.66439605504989 : 3.73206647840153); (8.66439605504989 : 4.375)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/OKBDataContext/Algorithm/Algorithm_Experiment" />
       <nodes>
@@ -361,5 +361,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(13.25 : 4.6); (13 : 4.6)]" fixedFrom="NotFixed" fixedTo="NotFixed">
+    <associationConnector edgePoints="[(13.25 : 4.6); (13 : 4.6)]" fixedFrom="Algorithm" fixedTo="Algorithm">
       <AssociationMoniker Name="/OKBDataContext/ProblemParameter/ProblemParameter_ProblemParameterBlobValue" />
       <nodes>
@@ -617,5 +617,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(4.75 : 3.35); (5 : 3.35)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(4.75 : 3.35); (5 : 3.35)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/OKBDataContext/Algorithm/Algorithm_AlgorithmData" />
       <nodes>
@@ -644,5 +644,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(13.25 : 3.35); (13 : 3.35)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(13.25 : 3.27707098556576); (13 : 3.27707098556576)]" fixedFrom="Algorithm" fixedTo="Algorithm">
       <AssociationMoniker Name="/OKBDataContext/Problem/Problem_ProblemData" />
       <nodes>
Index: /branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/HeuristicLab.Services.OKB.DataTransfer-3.3.csproj
===================================================================
--- /branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/HeuristicLab.Services.OKB.DataTransfer-3.3.csproj	(revision 4480)
+++ /branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/HeuristicLab.Services.OKB.DataTransfer-3.3.csproj	(revision 4481)
@@ -51,4 +51,7 @@
     <Compile Include="Algorithm.cs" />
     <Compile Include="AlgorithmData.cs" />
+    <Compile Include="ProblemData.cs" />
+    <Compile Include="Problem.cs" />
+    <Compile Include="ProblemClass.cs" />
     <Compile Include="DataType.cs" />
     <Compile Include="User.cs" />
Index: /branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Problem.cs
===================================================================
--- /branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Problem.cs	(revision 4481)
+++ /branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Problem.cs	(revision 4481)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public class Problem : NamedOKBItem {
+    [DataMember]
+    public long PlatformId { get; set; }
+    [DataMember]
+    public long ProblemClassId { get; set; }
+  }
+}
Index: /branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/ProblemClass.cs
===================================================================
--- /branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/ProblemClass.cs	(revision 4481)
+++ /branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/ProblemClass.cs	(revision 4481)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public class ProblemClass : NamedOKBItem { }
+}
Index: /branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/ProblemData.cs
===================================================================
--- /branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/ProblemData.cs	(revision 4481)
+++ /branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/ProblemData.cs	(revision 4481)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public class ProblemData {
+    [DataMember]
+    public long ProblemId { get; set; }
+    [DataMember]
+    public long DataTypeId { get; set; }
+    [DataMember]
+    public byte[] Data { get; set; }
+  }
+}
Index: /branches/OKB/HeuristicLab.Services.OKB/3.3/AdminService.cs
===================================================================
--- /branches/OKB/HeuristicLab.Services.OKB/3.3/AdminService.cs	(revision 4480)
+++ /branches/OKB/HeuristicLab.Services.OKB/3.3/AdminService.cs	(revision 4481)
@@ -43,9 +43,16 @@
       }
     }
-    public void StorePlatform(DataTransfer.Platform dto) {
+    public long AddPlatform(DataTransfer.Platform dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Platform entity = Convert.ToEntity(dto); entity.Id = 0;
+        okb.Platforms.InsertOnSubmit(entity);
+        okb.SubmitChanges();
+        return entity.Id;
+      }
+    }
+    public void UpdatePlatform(DataTransfer.Platform dto) {
       using (OKBDataContext okb = new OKBDataContext()) {
         DataAccess.Platform entity = okb.Platforms.FirstOrDefault(x => x.Id == dto.Id);
-        if (entity == null) okb.Platforms.InsertOnSubmit(Convert.ToEntity(dto));
-        else Convert.ToEntity(dto, entity);
+        Convert.ToEntity(dto, entity);
         okb.SubmitChanges();
       }
@@ -60,4 +67,39 @@
     #endregion
 
+    #region DataType Methods
+    public DataTransfer.DataType GetDataType(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return Convert.ToDto(okb.DataTypes.FirstOrDefault(x => x.Id == id));
+      }
+    }
+    public IEnumerable<DataTransfer.DataType> GetDataTypes() {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return okb.DataTypes.Select(x => Convert.ToDto(x)).ToArray();
+      }
+    }
+    public long AddDataType(DataTransfer.DataType dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.DataType entity = Convert.ToEntity(dto); entity.Id = 0;
+        okb.DataTypes.InsertOnSubmit(entity);
+        okb.SubmitChanges();
+        return entity.Id;
+      }
+    }
+    public void UpdateDataType(DataTransfer.DataType dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.DataType entity = okb.DataTypes.FirstOrDefault(x => x.Id == dto.Id);
+        Convert.ToEntity(dto, entity);
+        okb.SubmitChanges();
+      }
+    }
+    public void DeleteDataType(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.DataType entity = okb.DataTypes.FirstOrDefault(x => x.Id == id);
+        if (entity != null) okb.DataTypes.DeleteOnSubmit(entity);
+        okb.SubmitChanges();
+      }
+    }
+    #endregion
+
     #region AlgorithmClass Methods
     public DataTransfer.AlgorithmClass GetAlgorithmClass(long id) {
@@ -71,9 +113,16 @@
       }
     }
-    public void StoreAlgorithmClass(DataTransfer.AlgorithmClass dto) {
+    public long AddAlgorithmClass(DataTransfer.AlgorithmClass dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.AlgorithmClass entity = Convert.ToEntity(dto); entity.Id = 0;
+        okb.AlgorithmClasses.InsertOnSubmit(entity);
+        okb.SubmitChanges();
+        return entity.Id;
+      }
+    }
+    public void UpdateAlgorithmClass(DataTransfer.AlgorithmClass dto) {
       using (OKBDataContext okb = new OKBDataContext()) {
         DataAccess.AlgorithmClass entity = okb.AlgorithmClasses.FirstOrDefault(x => x.Id == dto.Id);
-        if (entity == null) okb.AlgorithmClasses.InsertOnSubmit(Convert.ToEntity(dto));
-        else Convert.ToEntity(dto, entity);
+        Convert.ToEntity(dto, entity);
         okb.SubmitChanges();
       }
@@ -99,9 +148,16 @@
       }
     }
-    public void StoreAlgorithm(DataTransfer.Algorithm dto) {
+    public long AddAlgorithm(DataTransfer.Algorithm dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Algorithm entity = Convert.ToEntity(dto); entity.Id = 0;
+        okb.Algorithms.InsertOnSubmit(entity);
+        okb.SubmitChanges();
+        return entity.Id;
+      }
+    }
+    public void UpdateAlgorithm(DataTransfer.Algorithm dto) {
       using (OKBDataContext okb = new OKBDataContext()) {
         DataAccess.Algorithm entity = okb.Algorithms.FirstOrDefault(x => x.Id == dto.Id);
-        if (entity == null) okb.Algorithms.InsertOnSubmit(Convert.ToEntity(dto));
-        else Convert.ToEntity(dto, entity);
+        Convert.ToEntity(dto, entity);
         okb.SubmitChanges();
       }
@@ -119,5 +175,5 @@
       }
     }
-    public void StoreAlgorithmUsers(long algorithmId, IEnumerable<Guid> users) {
+    public void UpdateAlgorithmUsers(long algorithmId, IEnumerable<Guid> users) {
       using (OKBDataContext okb = new OKBDataContext()) {
         okb.AlgorithmUsers.DeleteAllOnSubmit(okb.AlgorithmUsers.Where(x => x.AlgorithmId == algorithmId));
@@ -134,5 +190,5 @@
       }
     }
-    public void StoreAlgorithmData(DataTransfer.AlgorithmData dto) {
+    public void UpdateAlgorithmData(DataTransfer.AlgorithmData dto) {
       using (OKBDataContext okb = new OKBDataContext()) {
         DataAccess.AlgorithmData entity = okb.AlgorithmDatas.FirstOrDefault(x => x.AlgorithmId == dto.AlgorithmId);
@@ -144,27 +200,97 @@
     #endregion
 
-    #region DataType Methods
-    public DataTransfer.DataType GetDataType(long id) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return Convert.ToDto(okb.DataTypes.FirstOrDefault(x => x.Id == id));
-      }
-    }
-    public IEnumerable<DataTransfer.DataType> GetDataTypes() {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return okb.DataTypes.Select(x => Convert.ToDto(x)).ToArray();
-      }
-    }
-    public void StoreDataType(DataTransfer.DataType dto) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        DataAccess.DataType entity = okb.DataTypes.FirstOrDefault(x => x.Id == dto.Id);
-        if (entity == null) okb.DataTypes.InsertOnSubmit(Convert.ToEntity(dto));
+    #region ProblemClass Methods
+    public DataTransfer.ProblemClass GetProblemClass(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return Convert.ToDto(okb.ProblemClasses.FirstOrDefault(x => x.Id == id));
+      }
+    }
+    public IEnumerable<DataTransfer.ProblemClass> GetProblemClasses() {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return okb.ProblemClasses.Select(x => Convert.ToDto(x)).ToArray();
+      }
+    }
+    public long AddProblemClass(DataTransfer.ProblemClass dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.ProblemClass entity = Convert.ToEntity(dto); entity.Id = 0;
+        okb.ProblemClasses.InsertOnSubmit(entity);
+        okb.SubmitChanges();
+        return entity.Id;
+      }
+    }
+    public void UpdateProblemClass(DataTransfer.ProblemClass dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.ProblemClass entity = okb.ProblemClasses.FirstOrDefault(x => x.Id == dto.Id);
+        Convert.ToEntity(dto, entity);
+        okb.SubmitChanges();
+      }
+    }
+    public void DeleteProblemClass(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.ProblemClass entity = okb.ProblemClasses.FirstOrDefault(x => x.Id == id);
+        if (entity != null) okb.ProblemClasses.DeleteOnSubmit(entity);
+        okb.SubmitChanges();
+      }
+    }
+    #endregion
+
+    #region Problem Methods
+    public DataTransfer.Problem GetProblem(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return Convert.ToDto(okb.Problems.FirstOrDefault(x => x.Id == id));
+      }
+    }
+    public IEnumerable<DataTransfer.Problem> GetProblems() {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return okb.Problems.Select(x => Convert.ToDto(x)).ToArray();
+      }
+    }
+    public long AddProblem(DataTransfer.Problem dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Problem entity = Convert.ToEntity(dto); entity.Id = 0;
+        okb.Problems.InsertOnSubmit(entity);
+        okb.SubmitChanges();
+        return entity.Id;
+      }
+    }
+    public void UpdateProblem(DataTransfer.Problem dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Problem entity = okb.Problems.FirstOrDefault(x => x.Id == dto.Id);
+        Convert.ToEntity(dto, entity);
+        okb.SubmitChanges();
+      }
+    }
+    public void DeleteProblem(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Problem entity = okb.Problems.FirstOrDefault(x => x.Id == id);
+        if (entity != null) okb.Problems.DeleteOnSubmit(entity);
+        okb.SubmitChanges();
+      }
+    }
+    public IEnumerable<Guid> GetProblemUsers(long problemId) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return okb.ProblemUsers.Where(x => x.ProblemId == problemId).Select(x => x.UserId).ToArray();
+      }
+    }
+    public void UpdateProblemUsers(long problemId, IEnumerable<Guid> users) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        okb.ProblemUsers.DeleteAllOnSubmit(okb.ProblemUsers.Where(x => x.ProblemId == problemId));
+        okb.ProblemUsers.InsertAllOnSubmit(users.Select(x => new DataAccess.ProblemUser { ProblemId = problemId, UserId = x }));
+        okb.SubmitChanges();
+      }
+    }
+    #endregion
+
+    #region ProblemData Methods
+    public DataTransfer.ProblemData GetProblemData(long problemId) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return Convert.ToDto(okb.ProblemDatas.FirstOrDefault(x => x.ProblemId == problemId));
+      }
+    }
+    public void UpdateProblemData(DataTransfer.ProblemData dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.ProblemData entity = okb.ProblemDatas.FirstOrDefault(x => x.ProblemId == dto.ProblemId);
+        if (entity == null) okb.ProblemDatas.InsertOnSubmit(Convert.ToEntity(dto));
         else Convert.ToEntity(dto, entity);
-        okb.SubmitChanges();
-      }
-    }
-    public void DeleteDataType(long id) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        DataAccess.DataType entity = okb.DataTypes.FirstOrDefault(x => x.Id == id);
-        if (entity != null) okb.DataTypes.DeleteOnSubmit(entity);
         okb.SubmitChanges();
       }
Index: /branches/OKB/HeuristicLab.Services.OKB/3.3/Convert.cs
===================================================================
--- /branches/OKB/HeuristicLab.Services.OKB/3.3/Convert.cs	(revision 4480)
+++ /branches/OKB/HeuristicLab.Services.OKB/3.3/Convert.cs	(revision 4481)
@@ -28,11 +28,29 @@
     #region Platform
     public static DT.Platform ToDto(DA.Platform source) {
+      if (source == null) return null;
       return new DT.Platform { Id = source.Id, Name = source.Name, Description = source.Description };
     }
     public static DA.Platform ToEntity(DT.Platform source) {
+      if (source == null) return null;
       return new DA.Platform { Id = source.Id, Name = source.Name, Description = source.Description };
     }
     public static void ToEntity(DT.Platform source, DA.Platform target) {
-      target.Id = source.Id; target.Name = source.Name; target.Description = source.Description;
+      if ((source != null) && (target != null))
+        target.Id = source.Id; target.Name = source.Name; target.Description = source.Description;
+    }
+    #endregion
+
+    #region DataType
+    public static DT.DataType ToDto(DA.DataType source) {
+      if (source == null) return null;
+      return new DT.DataType { Id = source.Id, Name = source.Name, SqlName = source.SqlName, PlatformId = source.PlatformId };
+    }
+    public static DA.DataType ToEntity(DT.DataType source) {
+      if (source == null) return null;
+      return new DA.DataType { Id = source.Id, Name = source.Name, SqlName = source.SqlName, PlatformId = source.PlatformId };
+    }
+    public static void ToEntity(DT.DataType source, DA.DataType target) {
+      if ((source != null) && (target != null))
+        target.Id = source.Id; target.Name = source.Name; target.SqlName = source.SqlName; target.PlatformId = source.PlatformId;
     }
     #endregion
@@ -40,11 +58,14 @@
     #region AlgorithmClass
     public static DT.AlgorithmClass ToDto(DA.AlgorithmClass source) {
+      if (source == null) return null;
       return new DT.AlgorithmClass { Id = source.Id, Name = source.Name, Description = source.Description };
     }
     public static DA.AlgorithmClass ToEntity(DT.AlgorithmClass source) {
+      if (source == null) return null;
       return new DA.AlgorithmClass { Id = source.Id, Name = source.Name, Description = source.Description };
     }
     public static void ToEntity(DT.AlgorithmClass source, DA.AlgorithmClass target) {
-      target.Id = source.Id; target.Name = source.Name; target.Description = source.Description;
+      if ((source != null) && (target != null))
+        target.Id = source.Id; target.Name = source.Name; target.Description = source.Description;
     }
     #endregion
@@ -52,11 +73,14 @@
     #region Algorithm
     public static DT.Algorithm ToDto(DA.Algorithm source) {
+      if (source == null) return null;
       return new DT.Algorithm { Id = source.Id, Name = source.Name, Description = source.Description, PlatformId = source.PlatformId, AlgorithmClassId = source.AlgorithmClassId };
     }
     public static DA.Algorithm ToEntity(DT.Algorithm source) {
+      if (source == null) return null;
       return new DA.Algorithm { Id = source.Id, Name = source.Name, Description = source.Description, PlatformId = source.PlatformId, AlgorithmClassId = source.AlgorithmClassId };
     }
     public static void ToEntity(DT.Algorithm source, DA.Algorithm target) {
-      target.Id = source.Id; target.Name = source.Name; target.Description = source.Description; target.PlatformId = source.PlatformId; target.AlgorithmClassId = source.AlgorithmClassId;
+      if ((source != null) && (target != null))
+        target.Id = source.Id; target.Name = source.Name; target.Description = source.Description; target.PlatformId = source.PlatformId; target.AlgorithmClassId = source.AlgorithmClassId;
     }
     #endregion
@@ -64,23 +88,59 @@
     #region AlgorithmData
     public static DT.AlgorithmData ToDto(DA.AlgorithmData source) {
+      if (source == null) return null;
       return new DT.AlgorithmData { AlgorithmId = source.AlgorithmId, DataTypeId = source.DataTypeId, Data = source.Data.ToArray() };
     }
     public static DA.AlgorithmData ToEntity(DT.AlgorithmData source) {
+      if (source == null) return null;
       return new DA.AlgorithmData { AlgorithmId = source.AlgorithmId, DataTypeId = source.DataTypeId, Data = new Binary(source.Data) };
     }
     public static void ToEntity(DT.AlgorithmData source, DA.AlgorithmData target) {
-      target.AlgorithmId = source.AlgorithmId; target.DataTypeId = source.DataTypeId; target.Data = new Binary(source.Data);
+      if ((source != null) && (target != null))
+        target.AlgorithmId = source.AlgorithmId; target.DataTypeId = source.DataTypeId; target.Data = new Binary(source.Data);
     }
     #endregion
 
-    #region DataType
-    public static DT.DataType ToDto(DA.DataType source) {
-      return new DT.DataType { Id = source.Id, Name = source.Name, SqlName = source.SqlName, PlatformId = source.PlatformId };
+    #region ProblemClass
+    public static DT.ProblemClass ToDto(DA.ProblemClass source) {
+      if (source == null) return null;
+      return new DT.ProblemClass { Id = source.Id, Name = source.Name, Description = source.Description };
     }
-    public static DA.DataType ToEntity(DT.DataType source) {
-      return new DA.DataType { Id = source.Id, Name = source.Name, SqlName = source.SqlName, PlatformId = source.PlatformId };
+    public static DA.ProblemClass ToEntity(DT.ProblemClass source) {
+      if (source == null) return null;
+      return new DA.ProblemClass { Id = source.Id, Name = source.Name, Description = source.Description };
     }
-    public static void ToEntity(DT.DataType source, DA.DataType target) {
-      target.Id = source.Id; target.Name = source.Name; target.SqlName = source.SqlName; target.PlatformId = source.PlatformId;
+    public static void ToEntity(DT.ProblemClass source, DA.ProblemClass target) {
+      if ((source != null) && (target != null))
+        target.Id = source.Id; target.Name = source.Name; target.Description = source.Description;
+    }
+    #endregion
+
+    #region Algorithm
+    public static DT.Problem ToDto(DA.Problem source) {
+      if (source == null) return null;
+      return new DT.Problem { Id = source.Id, Name = source.Name, Description = source.Description, PlatformId = source.PlatformId, ProblemClassId = source.ProblemClassId };
+    }
+    public static DA.Problem ToEntity(DT.Problem source) {
+      if (source == null) return null;
+      return new DA.Problem { Id = source.Id, Name = source.Name, Description = source.Description, PlatformId = source.PlatformId, ProblemClassId = source.ProblemClassId };
+    }
+    public static void ToEntity(DT.Problem source, DA.Problem target) {
+      if ((source != null) && (target != null))
+        target.Id = source.Id; target.Name = source.Name; target.Description = source.Description; target.PlatformId = source.PlatformId; target.ProblemClassId = source.ProblemClassId;
+    }
+    #endregion
+
+    #region ProblemData
+    public static DT.ProblemData ToDto(DA.ProblemData source) {
+      if (source == null) return null;
+      return new DT.ProblemData { ProblemId = source.ProblemId, DataTypeId = source.DataTypeId, Data = source.Data.ToArray() };
+    }
+    public static DA.ProblemData ToEntity(DT.ProblemData source) {
+      if (source == null) return null;
+      return new DA.ProblemData { ProblemId = source.ProblemId, DataTypeId = source.DataTypeId, Data = new Binary(source.Data) };
+    }
+    public static void ToEntity(DT.ProblemData source, DA.ProblemData target) {
+      if ((source != null) && (target != null))
+        target.ProblemId = source.ProblemId; target.DataTypeId = source.DataTypeId; target.Data = new Binary(source.Data);
     }
     #endregion
Index: /branches/OKB/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj
===================================================================
--- /branches/OKB/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 4480)
+++ /branches/OKB/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 4481)
@@ -149,5 +149,5 @@
       <FlavorProperties GUID="{3D9AD99F-2412-4246-B90B-4EAA41C64699}">
         <WcfProjectProperties>
-          <AutoStart>True</AutoStart>
+          <AutoStart>False</AutoStart>
         </WcfProjectProperties>
       </FlavorProperties>
